<?php
/* --------------------------------------------------------------
	amazonadvpay.php 2014-07-15 mabr
	Gambio GmbH
	http://www.gambio.de
	Copyright (c) 2014 Gambio GmbH
	Released under the GNU General Public License (Version 2)
	[http://www.gnu.org/licenses/gpl-2.0.html]
	--------------------------------------------------------------
*/

defined('GM_HTTP_SERVER') or define('GM_HTTP_SERVER', HTTP_SERVER);

class amazonadvpay_ORIGIN {
	var $code, $title, $description;
	var $tmpOrders = true;
	var $tmpStatus = 0;
	var $enabled;

	public function __construct() {
		$t_order = $GLOBALS['order'];
		$this->code = 'amazonadvpay';
		$this->title = MODULE_PAYMENT_AMAZONADVPAY_TEXT_TITLE;
		$this->description = MODULE_PAYMENT_AMAZONADVPAY_TEXT_DESCRIPTION;
		$this->sort_order = MODULE_PAYMENT_AMAZONADVPAY_SORT_ORDER;
		$this->enabled = ((MODULE_PAYMENT_AMAZONADVPAY_STATUS == 'True') ? true : false);
		$this->info = MODULE_PAYMENT_AMAZONADVPAY_TEXT_INFO;
		$this->order_status = MODULE_PAYMENT_AMAZONADVPAY_ORDER_STATUS_ID;

		if(is_object($t_order)) {
			$this->update_status();
		}
	}

	function update_status() {
		$t_order = $GLOBALS['order'];
	}

	function javascript_validation() {
		return false;
	}

	function selection() {
		/*
		$selection = array(
			'id' => $this->code,
			'module' => $this->title,
			'description' => $this->info,
		);
		return $selection;
		*/
		return false;
	}

	function pre_confirmation_check() {
		return false;
	}

	function confirmation() {
		$confirmation = array(
			'title' => MODULE_PAYMENT_AMAZONADVPAY_TEXT_DESCRIPTION,
		);
		return $confirmation;
	}

	function refresh() {
	}

	function process_button() {
		$pb = '';
		$order = $GLOBALS['order'];
		$t_output = print_r($order, true);
		$coo_aap = MainFactory::create_object('AmazonAdvancedPayment');
		try
		{
			$t_order_reference_details = $coo_aap->set_order_amount($_SESSION['amazonadvpay_order_ref_id'], $order->info['total'], $order->info['currency']);
			//$t_order_reference_details = $coo_aap->get_order_reference_details($_SESSION['amazonadvpay_order_ref_id']);
			$t_output .= $t_order_reference_details->asXML();
		}
		catch(Exception $e)
		{
			$t_output .= $e->getMessage();
		}
		# $pb = '<pre>'.htmlspecialchars($t_output).'</pre>';
		return $pb;
	}

	function payment_action() {
		/*
		$order = $GLOBALS['order'];
		$orders_id = $GLOBALS['insert_id'];
		$order_totals = $GLOBALS['order_totals'];
		*/
		// order saved, finalize
		$insert_id = $GLOBALS['insert_id'];
		$order = new order($insert_id);
		//die(print_r($order, true));
		$coo_aap = MainFactory::create_object('AmazonAdvancedPayment');
		try
		{
			$coo_aap->confirm_order($_SESSION['amazonadvpay_order_ref_id'], $insert_id, $order->info['pp_total'], $order->info['currency']);
			$t_update_customer_data = $_SESSION['amazonadvpay_guest'] == true;
			$coo_aap->update_delivery_address($_SESSION['amazonadvpay_order_ref_id'], $insert_id, $t_update_customer_data);
			$coo_aap->delete_amazon_address_book_entries($_SESSION['customer_id']);
			if($coo_aap->erp_mode == false && $coo_aap->authorization_mode != 'manual')
			{
				$t_immediate_capture = $coo_aap->capture_mode == 'immediate';
				$t_authorization_timeout = $coo_aap->get_authorization_timeout();
				$t_authorization_note = '';
				if($coo_aap->mode == 'sandbox' && $_SESSION['comments'][0] == '{')
				{
					$t_authorization_note = $_SESSION['comments'];
					$coo_aap->log('Authorization in sandbox simulation mode, SellerAuthorizationNote: '.$t_authorization_note);
				}
				$t_authorization_response = $coo_aap->authorize_payment(
					$_SESSION['amazonadvpay_order_ref_id'],
					$order->info['pp_total'],
					$order->info['currency'],
					$t_authorization_timeout,
					$t_immediate_capture,
					$t_authorization_note
				);
				$t_authorization_details = $t_authorization_response->AuthorizeResult->AuthorizationDetails;
				$t_state = (string)$t_authorization_details->AuthorizationStatus->State;
				$t_reason_code = (string)$t_authorization_details->AuthorizationStatus->ReasonCode;
				if($t_state == 'Declined' && $t_reason_code == 'InvalidPaymentMethod')
				{
					$coo_aap->log('authorization Declined/InvalidPaymentMethod in checkout');
					//throw new Exception($coo_aap->get_text('checkout_error_invalid_payment_method'));
				}
			}
			unset($_SESSION['amazonadvpay_order_ref_id']);
		}
		catch(Exception $e)
		{
			$_SESSION['amazonadvpay_error'] = $e->getMessage();
			xtc_redirect(GM_HTTP_SERVER.DIR_WS_CATALOG.'checkout_payment.php?payment_error='.$this->code);
		}
		// mark order with final status
		xtc_db_query("UPDATE ".TABLE_ORDERS." SET orders_status='".$this->order_status."' WHERE orders_id='".$insert_id."'");

		//xtc_redirect(GM_HTTP_SERVER.DIR_WS_CATALOG.FILENAME_CHECKOUT_PROCESS);
		xtc_redirect(GM_HTTP_SERVER.DIR_WS_CATALOG.FILENAME_CHECKOUT_PROCESS);
	}

	function before_process() {
		return true;
	}

	function after_process() {
		return true;
	}

	function get_error() {
		$error = false;
		if(isset($_SESSION['amazonadvpay_error']))
		{
			$error = array('error' => $_SESSION['amazonadvpay_error']);
			unset($_SESSION['amazonadvpay_error']);
		}
		return $error;
	}

	function check() {
		if (!isset ($this->_check)) {
			$check_query = xtc_db_query("select configuration_value from ".TABLE_CONFIGURATION." where configuration_key = 'MODULE_PAYMENT_".  strtoupper($this->code) ."_STATUS'");
			$this->_check = xtc_db_num_rows($check_query);
		}
		return $this->_check;
	}

	function install() {
		$config = $this->_configuration();
		$sort_order = 0;
		foreach($config as $key => $data) {
			$install_query = "insert into ".TABLE_CONFIGURATION." ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, use_function, date_added) ".
					"values ('MODULE_PAYMENT_".strtoupper($this->code)."_".$key."', '".$data['configuration_value']."', '6', '".$sort_order."', '".addslashes($data['set_function'])."', '".addslashes($data['use_function'])."', now())";
			xtc_db_query($install_query);
			$sort_order++;
		}
	}

	function remove() {
		xtc_db_query("delete from ".TABLE_CONFIGURATION." where configuration_key in ('".implode("', '", $this->keys())."')");
	}

	function keys() {
		$ckeys = array_keys($this->_configuration());
		$keys = array();
		foreach($ckeys as $k) {
			$keys[] = 'MODULE_PAYMENT_'.strtoupper($this->code).'_'.$k;
		}
		return $keys;
	}

	function _configuration() {
		$config = array(
			'STATUS' => array(
				'configuration_value' => 'True',
				'set_function' => 'gm_cfg_select_option(array(\'True\', \'False\'), ',
			),
			'ALLOWED' => array(
				'configuration_value' => '',
			),
			'SORT_ORDER' => array(
				'configuration_value' => '0',
			),
			'ORDER_STATUS_ID' => array(
				'configuration_value' => '',
				'set_function' => 'xtc_cfg_pull_down_order_statuses(',
				'use_function' => 'xtc_get_order_status_name',
			),
		);

		return $config;
	}

}

MainFactory::load_origin_class('amazonadvpay');